<?php
class DsmFacebookTimeline{

    // use this instagram access token generator http://instagram.pixelunion.net/
    public $access_token="EAAjwHuTM4JkBAJa9gX5VH5BBjGhsRgef08ckgX3XOTpqVKZCcedxSklTP3GUqj3q1KJBPdk8uZBB1ALToyEVtAV3ej6ENNtVnEGZCGWQQBgspZCEFri4hZBaUoZAmGTv62uFNtA4Sj7ZCzCD8V6OjYAMlsEXZCfmPdNM3ZCXv8FHc2WBL8W5L2P5o";
    public $fb_page_id="369988600270788";
    public $fields = "id,attachments,message,picture,full_picture,actions,icon,created_time,from,story,reactions.limit(0).summary(true),likes.limit(0).summary(true),comments.limit(0).summary(true)";
    public $fields_comments="id,created,from,message,like_count";
    public $limit = 5;
    public $fb_graph_api_version="v7.0";
    public $post_id;

    public $json_link;
    public $next_page;
    public $feed_item_count;
    public $profile_photo_src;

    public $util;
    public $default_timezone="Asia/Manila";

	public function __construct(){
        // default timezone
        date_default_timezone_set($this->default_timezone);

        // utilities
		include_once "libs/php/util.php";
		$this->util=new Util();

        // set profile photo
    	$this->profile_photo_src="https://graph.facebook.com/{$this->fb_page_id}/picture?type=square";
	}

    public function getLikes_DsmFacebookTimeline(){

        $contents="";

        $json_link="https://graph.facebook.com/{$this->fb_graph_api_version}/{$this->post_id}/";
        $json_link.="likes?fields=id,name&access_token={$this->access_token}";

        $json = @file_get_contents($json_link);

        if($json===FALSE) {
        	die("Unable to get likes data.");
        }

        else{
        	$obj = json_decode($json, true);

        	$likes_count=count($obj['data']);

        	// show likers, show only 2 likers
        	if($likes_count==1){
        		$liker_id=$obj['data'][0]['id'];
        		$liker_name=$obj['data'][0]['name'];

        		$contents.="<a href='https://facebook.com/{$liker_id}/' target='_blank'>{$liker_name}</a> like this.";
        	}

        	else if($likes_count==2){
        		$liker_id=$obj['data'][0]['id'];
        		$liker_name=$obj['data'][0]['name'];

        		$liker_id_2=$obj['data'][1]['id'];
        		$liker_name_2=$obj['data'][1]['name'];

        		$contents.="<a href='https://facebook.com/{$liker_id}/' target='_blank'>{$liker_name}</a> and ";
        		$contents.="<a href='https://facebook.com/{$liker_id_2}/' target='_blank'>{$liker_name_2}</a> like this.";
        	}

        	else if($likes_count>2){
        		$liker_id=$obj['data'][0]['id'];
        		$liker_name=$obj['data'][0]['name'];

        		$liker_id_2=$obj['data'][1]['id'];
        		$liker_name_2=$obj['data'][1]['name'];

        		$contents.="<a href='https://facebook.com/{$liker_id}/' target='_blank'>{$liker_name}</a>, ";
        		$contents.="<a href='https://facebook.com/{$liker_id_2}/' target='_blank'>{$liker_name_2}</a> and many others like this.";
        	}
        }

        return $contents;
    }

    public function getComments_DsmFacebookTimeline(){
        $contents="";

        $json_link="https://graph.facebook.com/{$this->fb_graph_api_version}/{$this->post_id}/";
        $json_link.="comments?fields={$this->fields_comments}&access_token={$this->access_token}";

        $json = @file_get_contents($json_link);

        if($json===FALSE) {
        	die("Unable to get comments data.");
        }

        else{
        	$obj = json_decode($json, true);

        	$comments_count=count($obj['data']);

        	// show comments
        	if($comments_count>0){
        		foreach($obj['data'] as $comment){

        			$commenter_id = $comment['from']['id'];
        			$commenter_name = $comment['from']['name'];
        			$like_count=isset($comment['like_count']) ? $comment['like_count'] : 0;
        			$comment_like_count = $this->util->formatCount($like_count);
        			$message = $this->util->getNewStringWithMentions(htmlspecialchars_decode(str_replace("\n", "<br>", $comment['message'])));

        			$contents.="<div style='margin:.5em 0; width:100%; overflow:hidden;'>";
        				$contents.= "<div style='float:left; width:42px; height:42px; border:1px solid #999; margin:5px .5em 0 0;'>";
        					$contents.= "<img src='https://graph.facebook.com/{$commenter_id}/picture?type=square' style='width:40px; height:40px;' />";
        				$contents.= "</div>";
        				$contents.= "<div style='float:left; width:80%;'>";
        					$contents.= "<a href='https://facebook.com/{$commenter_id}/' target='_blank'>{$commenter_name}</a> {$message}";

        					$contents.= "<div style='float:left; width:100%;'>";
        						$contents.= "<i class='fa fa-thumbs-o-up'></i> {$comment_like_count}";
        					$contents.= "</div>";
        				$contents.= "</div>";
        			$contents.= "</div>"; // end
        		}
        	}
        }

        return $contents;
    }

    public function readFacebookTimeline_Dsm(){

        if(empty($this->json_link)){
        	$this->json_link="https://graph.facebook.com/{$this->fb_graph_api_version}/{$this->fb_page_id}/posts?access_token={$this->access_token}";
            $this->json_link.="&fields={$this->fields}&limit={$this->limit}";
        }

    	$json = @file_get_contents($this->json_link);

        // decode json
        $obj=array();
    	if($json===FALSE){ die("Unable to get data."); }
    	else{ $obj = json_decode($json, true); }

        // feed count
        $this->feed_item_count = count($obj['data']);

        // set next page
    	$this->next_page = isset($obj['paging']['next']) ? $obj['paging']['next'] : "";

        // return obj
        return $obj;
    }

    public function printContents_DsmFacebookTimeline(){
        $contents="";

        $contents.="<!-- pre-load loader images -->";
        $contents.="<img src='images/ajax-loader-like-comment.gif' style='display:none;' />";
        $contents.="<img src='images/ajax-loader.gif' style='display:none;' />";

        $contents.="<div class='container' style='margin-top:50px;'>";
            $contents.="<div class='row'>";

            $contents.="<div class='col-lg-12'>";
                $dsm_facebook_timeline=$this;
                $obj=$dsm_facebook_timeline->readFacebookTimeline_Dsm();

                // display timeline feed
            	ob_start();
            	include_once 'items_template.php';
            	$contents.=ob_get_contents();
            	ob_end_clean();

            	$contents.="<div id='last_item_loader'></div>";
            $contents.="</div>";

            $contents.="</div> <!-- /row -->";
        $contents.="</div> <!-- /container -->";

        return $contents;
    }

    // method for the 'head' section of index.php / page where you will put the photo albums
    public function printCSS_DsmFacebookTimeline(){

        $css="";

        $css.="<!-- bootstrap css -->";
        $css.="<link href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css' rel='stylesheet' media='screen'>";

        $css.="<!-- font awesome css -->";
        $css.="<link rel='stylesheet' href='https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css'>";

        $css.="<!-- custom css -->";
        $css.="<link rel='stylesheet' href='libs/css/custom.css'>";

        return $css;
    }

    // method before the closing 'body' tag of index.php / page where you will put the instagram photos
    public function printJavaScript_DsmFacebookTimeline(){

        $js="";

		$js.="<!-- jquery library -->";
		$js.="<script src='https://code.jquery.com/jquery-3.5.1.min.js'></script>";

		$js.="<!-- linkify -->";
		$js.="<script src='libs/js/jquery.linkify.min.js'></script>";

		$js.="<!-- custom javascript -->";
		$js.="<script src='libs/js/custom.js'></script>";

        return $js;
    }
}
?>
